//
// ioblink.cpp - Blinking LEDs sample
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>

#include "spinkit.h"

#define FALSE 0
#define TRUE 1

int main(int argc, char* argv[])
 {
  SPINKIT_HANDLE Spins[SPINKIT_MAX_DEVICES];
  int i, j, k;
  int numSpins;
  SPINKIT_DATA data;
  unsigned short sn[9];
  char snt[9];
  DWORD pid;
  SPINKIT_HANDLE devHandle;

  // Open device
  devHandle = SpinKitOpenDevice();
  if (devHandle == NULL)
   {
    printf("Failed to open device\n");
    exit(0);
   }
  // Get number of SpinWarriors in system
  numSpins = SpinKitGetNumDevs();
  printf("%d SpinWarriors in system\n", numSpins);
  // Get all SpinWarriors handles
  for (i = 0; i < numSpins; i++)
   {
    // Get device handle and init object
    Spins[i] = SpinKitGetDeviceHandle(i + 1);
    // Get serial number
    SpinKitGetSerialNumber(Spins[i], sn);
    pid = SpinKitGetProductId(Spins[i]);
    for (j = 0; j < 9; j++)
      snt[j] = sn[j];
    printf("%d PID %x, S/N \"%s\"\n", i + 1, (unsigned int) pid, snt);
   }

  for(;;)
    for (i = 0; i < numSpins; i++)
     {
      while (SpinKitReadNonBlocking(Spins[i], &data))
       {
        for (k = 0; k < 6; k++)
          printf("%d ", data.Spins[k]);
        for (k = 0; k < 7; k++)
          printf("%s", data.Buttons[k] != 0 ? "X" : "-");
        printf("\n");
       }
      usleep(10000);
     }
  // Close device
  SpinKitCloseDevice(devHandle);
  return 0;
 }
